
.include "m32def.inc"

;definirea const
.equ multiplier= 2740



; redefinirea registrilor
 .def flags = r2 
 .def temp  = r16
 .def itmp 	= r17
 .def pos 	= r18
 .def tmpH=R19
 .def tmpL=R20
 .def aL=R21
 .def aH=R22
 .def dataH=R23
 .def dataL=R24
 .def channel = r25
.dseg 
 VideoBuff: .BYTE 6  
 ADCResults: .Byte 2 	//vectorul cu rezultate a conversiei


.cseg	; segmentul de cod 
.org	0x0000
	rjmp	RESET	; Salt neconditionat

.org	INT0addr	; External Interrupt0 Vector Address
	reti

.org	INT1addr	; External Interrupt1 Vector Address
	reti

.org	INT2addr	; External Interrupt2 Vector Address
	reti
.org	OC2addr	    ; Output Compare2 Interrupt Vector Address
	reti 
.org	OVF2addr	; Overflow2 Interrupt Vector Address
	reti
.org	ICP1addr	; Input Capture1 Interrupt Vector Address
	reti

.org	OC1Aaddr	; Output Compare1A Interrupt Vector Address
	reti
.org	OC1Baddr	; Output Compare1B Interrupt Vector Address
	reti
.org	OVF1addr	; Overflow1 Interrupt Vector Address
	reti
.org	OC0addr	    ; Output Compare0 Interrupt Vector Address
	rjmp DisplayNext
	
	 
.org	OVF0addr	; Overflow0 Interrupt Vector Address
	reti
.org	SPIaddr	     ; SPI Interrupt Vector Address
	reti
.org	URXCaddr	; USART Receive Complete Interrupt Vector Address
	reti
.org	UDREaddr	; USART Data Register Empty Interrupt Vector Address
	reti
.org	UTXCaddr	; USART Transmit Complete Interrupt Vector Address
	reti

.org	ADCCaddr	; ADC Interrupt Vector Address
	rjmp End_Conversion

.org	ERDYaddr	; EEPROM Interrupt Vector Address
	reti
.org	ACIaddr 	; Analog Comparator Interrupt Vector Address
	reti
.org    TWIaddr   ; Irq. vector address for Two-Wire Interface
	reti
.org	SPMRaddr	; Store Program Memory Ready Interrupt Vector Address
	reti




End_Conversion:    ;Subrutina ce se va apela la sfirs conv. de la ADC
 		; comenzi pentru subruta data
	in flags, SREG   ; salvam temp. reg. de fanioane

	in itmp, ADCL		; preluam rezultatele conversiei
	sts  ADCResults, itmp
	in itmp, ADCH
	sts  ADCResults+1, itmp	

	sbi ADCSRA,ADSC 
    out SREG, flags   ; restabilim fanioanele
	RETI


//---------------------------------------------------------------
DisplayNext:    ;Subrutina de prelucrare a intreruperii
 		; comenzi pentru subruta data
		in flags, SREG
		ser itmp
		out PORTC, itmp	; stingim toate indicatoarele
		LD  itmp, X+
		out PORTB, itmp	;afishem noul cod
		out PORTC, pos		; aprindem indicatoru
		
		asr pos
		brcs	end_dispaly
		; reinitializam (incepem din nou)
		ldi XL, low(VideoBuff)	; Adressa de inceput a mesajului (in memoria Flash)
		ldi XH, High(VideoBuff)
		ldi pos, ~(1<<PC5)
  end_dispaly:
		out SREG, flags
	 	reti


; Programul principal
//--------------------------------------------------------------	 
RESET:	 
     ldi temp, Low(RAMEND) 	; initializam stiva
	 out SPL, temp
	 ldi temp, High(RAMEND) 
	 out SPH, temp
 
	 CLR temp				;resetam temp
	 		; Setam ca intrare PORTA 	
	 out DDRA, temp			; Setam ca intrare PORTB
	 out DDRD, temp			; Setam ca intrare PORTD


	 SER temp
	 out DDRC, temp		; Setam ca iesire PORTC
	 out DDRB, temp

	ldi temp, 78
	out OCR0, temp
	ldi temp,(1<<WGM01)|(0<<CS02)|(1<<CS01)|(1<<CS00) ; CTC 1 la 64
	out TCCR0, temp 

	ldi temp,(1<<OCIE0); permitem intreruperea Input Capture
	out TIMSK, temp 
	
	ldi XL, low(VideoBuff)	; Adressa de inceput a mesajului (in memoria Flash)
	ldi XH, High(VideoBuff)
	ldi pos, ~(1<<PC5)


	ldi temp, (1<<REFS0)|(1<<MUX2)|(1<<MUX1)|(1<<MUX0)  ; setam referinta la ADC, AVCC si canalul 7
	out ADMUX, temp
	ldi temp, (1<<ADEN)|(1<<ADIE)|(1<<ADSC)|(1<<ADPS2)|(1<<ADPS1)  ;activam convertorul si lansam conversia
	out ADCSRA, temp


	SEI

	ldi temp, 0x3F
	sts VideoBuff, temp
	ldi temp, 0x06
	sts VideoBuff+1, temp	
	ldi temp, 0x5B
	sts VideoBuff+2, temp

	ldi temp, 0x4F
	sts VideoBuff+3, temp
	
	ldi temp, 0x66
	sts VideoBuff+4, temp
	ldi temp, 0x6D
	sts VideoBuff+5, temp

//////////////////////////////////////////////////////////////////
 MAIN: ; programul principal
	cli
	lds DataL,  ADCResults
	lds DataH,  ADCResults+1
	sei
		//incarcam coeficinet
	
	ldi tmpL,Low(multiplier)
	ldi tmpH,High(multiplier)
	
	mul tmpL,DataL
	mov aL,r0
	mov aH,r1

	mul tmpL,DataH
	mov r3,r0
	mov r4,r1

	mul tmpH,DataL
	mov r5,r0
	mov r6,r1

	mul tmpH,DataH
	mov r7,r0
	mov r8,r1


	add aL,r3
	adc aH,r4
clr tmpH
	add aH,r5
	adc r6,tmpH

	add r6,r7
	adc r8,tmpH
	

ldi tmpH,4
/*
divideby:
	asr r8
	ror r6
	ror aH

	dec tmpH
	brne divideby
*/
//aruncam aL <=> impatirea la 256
	mov dataH,r6
	mov DataL,aH
	
	rcall BinToDec 
 rjmp main


//----------------------------------------------------
  BinToDec:
	CLR tmpL
	SBRS dataH, 7
	rjmp positiv
	sub tmpL, DataL		// Inversam numaru
	sbc tmpL, DataH
	LDI tmpL,0X40 		// Incarcam codula la simbolul (-)
  positiv:	
	STS Videobuff, tmpL
	CLR tmpL
	ldi aL, Low(10000)
	ldi aH, High(10000)
  zecemii:
  	CP dataL, aL
	CPC dataH, aH
	BRLO endzecemii
	SUB dataL, aL
	SBC  dataH, aH
	INC tmpL
	rjmp zecemii
 endzecemii:
	RCALL getcode
	clr tmpL  		;stergen zero din fata nr
	STS VideoBuff+1, tmpL

// miile
	CLR tmpL
	ldi aL, Low(1000)
	ldi aH, High(1000)	
 mii:
	CP dataL, aL
	CPC dataH, aH
	BRLO endmii
	SUB dataL, aL
	SBC dataH, aH
	INC tmpL
	Rjmp mii
 endmii:
	RCALL getcode
	STS videobuff+2, tmpL

// Sute
	clr tmpL
	ldi aL, Low(100)
	ldi aH, High(100)	
 sute:
	CP dataL, aL
	CPC dataH, aH
	BRLO endSute
	SUB dataL, aL
	SBC dataH, aH
	INC tmpL
	Rjmp Sute
 endSute:
	RCALL getcode
	ORI tmpL,(1<<PB7)
	STS VideoBuff+3, tmpL

// zecimi
	CLR tmpL
	ldi aL, Low(10)
	ldi aH, High(10)
 zecimi:
	CP dataL, aL
	CPC dataH, aH
	BRLO endZecimi
	SUB dataL, aL
	SBC dataH, aH
	INC tmpL
	Rjmp Zecimi
 endZecimi:
	RCALL getcode
	STS VideoBuff+4, tmpL
// unitatile
	mov tmpL, DataL		
	RCALL getcode
	STS VideoBuff+5, tmpL
	RET

///////////////////////////////////////////
GetCode:
	CLR tmpH
	Ldi ZL, LOW(CodeTable*2)
	Ldi ZH, High(CodeTable*2)
	ADD ZL, tmpL
	ADC ZH, tmpH
	LPM tmpL, Z
	RET


 CodeTable:
.DB 0x3f, 0x06, 0x5b, 0x4f, 0x66, 0x6d, 0x7d, 0x07, 0x7f, 0x6f
   
